﻿using UnityEngine;
using System.Collections;

public class Spin : MonoBehaviour 
{
	public enum _Mode{
		RotateLocal,
		RotateWorld,
		RollLocal,
		RollWorld
	}
	public Vector3 speed; 
	public _Mode Mode = _Mode.RotateLocal;   
    private Quaternion StartRot;
    private bool SetStartRot;
    [Space(10),Tooltip("If null spins self")]
    public Transform SpinOther;

	void OnEnable()
	{
		if(SpinOther == null)
			SpinOther = transform;
			
		if(!SetStartRot)
		{
			StartRot = SpinOther.rotation;
			SetStartRot = true;
		}	
		SpinOther.rotation = StartRot;
	}
	void Update () 
	{
		// Like a ball rolling
		if(Mode == _Mode.RollLocal || Mode == _Mode.RollWorld)
		{
			Quaternion q = Quaternion.Euler (speed * Time.deltaTime);
			if (Mode == _Mode.RollLocal)
	        {
				SpinOther.localRotation = q * SpinOther.localRotation;
			}else if(Mode == _Mode.RollWorld){
				SpinOther.rotation = q * SpinOther.rotation;
	        }
		}else if(Mode == _Mode.RotateLocal || Mode == _Mode.RotateWorld){ // adds rotation to the transfrom

			if (Mode == _Mode.RotateLocal)
			{
				SpinOther.Rotate(speed * Time.deltaTime, Space.Self);
			}else if(Mode == _Mode.RotateWorld){
				SpinOther.Rotate(speed * Time.deltaTime, Space.World);
			}
		}
	}
}
