﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class VectorCross : MonoBehaviour
{

    public Transform A;
    public Transform B;
    public Transform C;
    public Transform D;

    void OnDrawGizmos()
    {
        
        Gizmos.DrawSphere(A.position, 0.1f);
        Gizmos.DrawLine(A.position, A.position + CrossDirection(D.position, A.position, B.position) * 3);

        Gizmos.DrawSphere(B.position, 0.1f);
        Gizmos.DrawLine(B.position, B.position + CrossDirection(A.position, B.position, C.position) * 3);

        Gizmos.DrawSphere(C.position, 0.1f);
        Gizmos.DrawLine(C.position, C.position + CrossDirection(B.position, C.position, D.position) * 3);

        Gizmos.DrawSphere(D.position, 0.1f);
        Gizmos.DrawLine(D.position, D.position + CrossDirection(C.position, D.position, A.position) * 3);

        Vector3 Middle = (A.position + B.position + C.position + D.position) / 4;
        Vector3 MiddleDir = (CrossDirection(D.position, A.position, B.position)
            + CrossDirection(A.position, B.position, C.position)
            + CrossDirection(B.position, C.position, D.position)
            + CrossDirection(C.position, D.position, A.position)) / 4;


        Gizmos.DrawSphere(Middle, 0.1f);
        Gizmos.DrawLine(Middle, Middle + MiddleDir * 3);



    }
    Vector3 CrossDirection(Vector3 a, Vector3 b, Vector3 c)
    {
        Vector3 side1 = b - a;
        Vector3 side2 = c - a;
        return Vector3.Cross(side1, side2).normalized;
    }
}
